import axios from 'axios'

// hyper cycle addresses in chronological order (oldest first)
const addresses = [{address:"41a006ecb7cbada14fe1fed3f6419b99",enterpriseKey:"4752b023-ae38-407e-a1c6-5a38dd774a4a",twinKey:"49165637-96e9-4737-bd3f-67c402ecee05"},
                   {address:"41ca56b8a4ac2d17bd5e4927e04425ca",enterpriseKey:"a14bf32a-46a6-4c5c-9bc3-da9879a2e4ae",twinKey:"46a3a4c2-2acc-48f9-8b25-4b2e503df72a"},
                   {address:"41856e3ffe4689d3c0e2fcfc2b5723ae",enterpriseKey:"f0b12141-9b13-4482-b2de-2296b53a3637",twinKey:"a4a9ffc0-9eeb-4c7e-814f-9129e64f76b7"},
                   {address:"41a7094b1dc408f7e3eb623e1176b7d2",enterpriseKey:"d6709bba-6d8b-41c8-88b6-e9ff1238a2e1",twinKey:"e82a1ed6-a52e-4e55-b211-e0e4ec62dd9a"},
                   {address:"4185b98b32d99e612a1fafc991aafe47",enterpriseKey:"d15f6556-7df5-428c-9f37-dbe35cb84652",twinKey:"8e8cecea-d50b-4b11-ae06-f685f1cf882a"},
                   {address:"41fca846c07605b14d8246fedafd4380",enterpriseKey:"b7bdd00e-7aa8-45dd-999c-d6fcc93a540a",twinKey:"eeb8f134-aa6d-473a-95c6-277f3ee0dd95"},
                   {address:"411cee795a34e872983f70dad471d08e",enterpriseKey:"62598c63-6d1c-4c9d-9ee1-b9cde85bcab7",twinKey:"ab4af71e-2037-47aa-aabc-8cdcad5954f5"},
                   {address:"41450ea2ea93483e5ad2ef488ac31ab8",enterpriseKey:"2a971c92-e992-4e3b-976f-2af05de32dab",twinKey:"cc80a254-96ff-43cd-8d60-e5fa6fe2bf38"},
                   {address:"4103292a8959ac7bcd61153994533cd1",enterpriseKey:"8232d9ba-e988-4eec-a019-171c3bf4b108",twinKey:"b0632413-f816-4fed-9137-3e4a09d337a7"},
                   {address:"41650cdfecf8a4c5b4f1d197ebb8b427",enterpriseKey:"68e4ef79-d534-44ae-8b74-8c061e217cc0",twinKey:"417c1d26-f614-49b2-94c9-2112c7f91e4d"},
                   {address:"41752261ae24263348ccb986debb66c9",enterpriseKey:"4b3efb72-3356-41a9-bc2b-f3aea66c5306",twinKey:"aa6252cf-94fa-4959-94cb-0f107468445c"},
                   {address:"41c8ac9e24228469f31543bdf122d2c2",enterpriseKey:"5515ed64-b71a-45d5-93f5-1df41ed1a6be",twinKey:"f4446b6a-cd25-45a2-9d90-196f804022d5"},
                   {address:"416ae5be7166ff68fb556c19fa00bf35",enterpriseKey:"edc895c3-da12-4c5f-b932-f8d62900d10e",twinKey:"79420e29-a5d8-4c0f-81b7-5abdb1562c7e"}]

let root = "41a71260e9f2dbb0821f78a43537a22340f5f6fcb07600edd650d09d52e3677f37"

async function createDQ(idx) {
    console.log("CREATING DQ")
    const address = addresses[idx].address
    const enterpriseKey = addresses[idx].enterpriseKey
    const r = await axios.post(`https://${address}.hypercycle.biz.todaq.net/dq?apiKey=${enterpriseKey}`,
                               {
                                    "quantity": 1000000,
                                    "displayPrecision": 0,
                                    "mintingInfo": "Yet another, another test token for HyperCycle! (2023-08-25T20:27:17)",
                                    "popTop": "41f8d909599fea982fffef34a3e0c0525391664269172010a817fd9952f3ee77ea"
                                })
    root = r.data.root
    console.log("CREATED DQ: ", root)

}

async function transfer(idxSend, idxDest, qty) {
    const sender = addresses[idxSend].address
    const enterpriseKey = addresses[idxSend].enterpriseKey
    const dest = addresses[idxDest].address
    console.log(`SENDING ${qty} FROM ${sender} TO ${dest}`)
    const r = await axios.post(`https://${sender}.hypercycle.biz.todaq.net/dq/${root}/transfer?apiKey=${enterpriseKey}`,
                               {
                                    "amount": qty,
                                    "destination": `https://${dest}.hypercycle.biz.todaq.net`
                                })                            
    const files = r.data.files
    console.log(`SENDING COMPLETE, FILES ${files}`)
    return files
}

async function displayBalance(idx) {
    const address = addresses[idx].address
    const enterpriseKey = addresses[idx].enterpriseKey
    const r = await axios.get(`https://${address}.hypercycle.biz.todaq.net/dq/${root}?apiKey=${enterpriseKey}`)
    console.log(`BALANCE FOR ${address}: ${r.data.balance}`)
}

async function performSchedule() {
    await createDQ(0)
    await transfer(0, 2, 5000)
    await displayBalance(0)
    await displayBalance(2)
    await transfer(2, 3, 400)
    await displayBalance(2)
    await displayBalance(3)
    await transfer(3, 1, 200)
    await displayBalance(1)
    await displayBalance(3)
    await transfer(3, 0, 100)
    await displayBalance(0)
    await displayBalance(3)
}

performSchedule()