import axios from 'axios';

const staging = {apiKey: '1e13c4bc-23e7-4513-8353-414a0c182ba3',
                 adminUrl: 'https://admin.tq.biz-staging.todaq.net/admin/twins/create',
                 tether: '41f6cec53f2a3ed7eff153c9e65ff7dff2746b0b8b5c2222adab923076581e28c6',
                 relay: 'https://dev.todaq.lol/api/hoist',
                 fileServer: 'https://cdn.dev.todaq.lol/next'};
const prod = {apiKey: '1ae2eca6-faa7-455b-87c7-535d720f4487',
              adminUrl: 'https://admin.tq.biz.todaq.net/admin/twins/create',
              tether: '41e3c2739b1aca19e18026f6c9416889c26700c04431624df2a7242e8fa8dd2d3c',
              relay: 'https://relay.todaq.net/api/hoist',
              fileServer: 'https://cdn.relay.todaq.net/next'};

const ts = Date.now();
const date = (new Date()).toISOString().slice(0, 10);

function mintingInfo(moniker) {
    return `{\"ts\":${ts}, \"info\":\"${date} - ${moniker} Heartbeat Coin\"}`
}

async function createTwin(twinTarget, relayTarget) {
    const d = await axios.post(twinTarget.adminUrl + "?apiKey=" + twinTarget.apiKey,
                               {relayUrl: relayTarget.relay,
                                remoteFileServerUrl: relayTarget.fileServer,
                                tetherHash: relayTarget.tether},
                                {headers: {'content-type': 'application/json'}});
    return d.data;
}

async function mint(twin, moniker) {
    const d = await axios.post("https://" + twin.hostname + "/dq?apiKey=" + twin.apiKeys[0],
                               {quantity: 999999,
                                displayPrecision: 1,
                                mintingInfo: mintingInfo(moniker)},
                                {headers: {'content-type': 'application/json'}});
    return d.data.root;
}

function lambdaPayload(twin0, twin1, root, humanMoniker, searchableMoniker, amt) {
    return {twins: 
             [{url: "https://" + twin0.hostname,
               apiKey: twin0.apiKeys[0]},
              {url: "https://" + twin1.hostname,
               apiKey: twin1.apiKeys[0]}],
             amt,
             dq: root,
             moniker: humanMoniker + " " + searchableMoniker};
}

async function createHeartbeat(twinTarget, relayTarget, humanMoniker, searchableMoniker) {
    const twin0 = await createTwin(twinTarget, relayTarget);
    const twin1 = await createTwin(twinTarget, relayTarget);
    const root = await mint(twin0, humanMoniker);
    return {send: lambdaPayload(twin0, twin1, root, humanMoniker, searchableMoniker + "[Send]", 1.4),
            receive: lambdaPayload(twin1, twin0, root, humanMoniker, searchableMoniker + "[Reverse]", 1.2)};
}

async function createAll() {
    //const prodProd = await createHeartbeat(prod, prod, "Production Twin / Production Relay", "[ProductionTwin/ProductionRelay]");
    const stagingStaging = await createHeartbeat(staging, staging, "Staging Twin / Staging Relay", "[StagingTwin/StagingRelay]");
    const stagingProd = await createHeartbeat(staging, prod, "Staging Twin / Production Relay", "[StagingTwin/ProductionRelay]");
    //console.log(JSON.stringify(prodProd.send, null, 2));
    //console.log(JSON.stringify(prodProd.receive, null, 2));
    console.log(JSON.stringify(stagingProd.send, null, 2));
    console.log(JSON.stringify(stagingProd.receive, null, 2));
    console.log(JSON.stringify(stagingStaging.send, null, 2));
    console.log(JSON.stringify(stagingStaging.receive, null, 2));
}

createAll();