import { RemoteRelayClient } from "../src/client/relay.js";
import { Atoms } from "../src/core/atoms.js";
import { Hash, Sha256 } from "../src/core/hash.js";
import { ArbitraryPacket } from "../src/core/packet.js";
import { Shield } from "../src/core/shield.js";
import fs from "fs-extra";
import { Twist } from "../src/core/twist.js";
import { ByteArray } from "../src/core/byte-array.js";
import { LocalInventoryClient } from "../src/client/inventory.js";
import { TodaClient } from "../src/client/client.js";


const salt = "8434c0fb-e960-47bf-abe1-6d509bb76c54";

const inv = new LocalInventoryClient("C:/Users/csulp/Downloads");
const address = Hash.fromHex("41fe9abd81b8a8992e6ceb979a0d3f5aaf7cc85e0d23cbd58a43b6e2060d55e731");
const client = new TodaClient(inv, "https://cdn.relay.todaq.net/next");
client._getSalt = () => new TextEncoder().encode(salt);

const f = new Twist(await client.get(address).getAtoms(), address);

const r = new RemoteRelayClient("https://relay.todaq.net/api/hoist",
                                "https://cdn.relay.todaq.net/next",
                                Hash.fromHex("41f4ccf85000931b21bcc8c4517fdac844a783d449148de705bee62953fd0723d0")); 

async function foo() {
    await r.hoist(f, Hash.fromHex("419a88a1d0d6ae877049e83c2b67256e321e796fac058e1dfc1332e047879ded5d"));
    await client._waitForHoist(f, r);
    console.log("SUCCESS!!!!");
}

foo().catch(e => console.error(e));

/*

function _generateShield(hash) {
    return new ArbitraryPacket(new ByteArray(saltBytes).concat(hash.toBytes()));
}

const f = "C:/Users/csulp/Downloads/41a45834871f4f6ab80b3ca8be29c48078d44b583f70f4d45521007c03fe461aa2";
const twist = Twist.fromBytes(fs.readFileSync(f));


const shieldHash = Hash.fromHex("414633c894acacc27fde94d7be10ae6dfb1d6952f6770b7bffe5f826f0a88843ab");
const shieldPacket = _generateShield(twist.getBodyHash());
const shieldAtoms = Atoms.fromPairs([[shieldHash, shieldPacket]]);
twist.addAtoms(shieldAtoms);


const lead = Hash.fromHex("41fe9abd81b8a8992e6ceb979a0d3f5aaf7cc85e0d23cbd58a43b6e2060d55e731");
const meet = Hash.fromHex("419a88a1d0d6ae877049e83c2b67256e321e796fac058e1dfc1332e047879ded5d");

const hoist = Shield.rigForHoist(lead, meet, shieldPacket);

console.log(hoist);

const r = new RemoteRelayClient("https://relay.todaq.net/api/hoist",
"https://cdn.relay.todaq.net/next",
Hash.fromHex("41f4ccf85000931b21bcc8c4517fdac844a783d449148de705bee62953fd0723d0"));

async function foo() {
    await r._hoist(Hash.fromHex("41f4ccf85000931b21bcc8c4517fdac844a783d449148de705bee62953fd0723d0"), hoist);
    for (let i = 0; i < 20; i ++) {
        console.log(i);
        await new Promise(r => setTimeout(r, 2000));
        const h = await r.getHoist(twist);
        if (h) {
            console.log("SUCCESS!");
            return;
        }
    }
    console.log("UH OH!!!!!");
}

foo();
*/