import { Atoms } from "../src/core/atoms.js";
import { ByteArray } from "../src/core/byte-array.js";
import { Sha256 } from "../src/core/hash.js";
import { ArbitraryPacket } from "../src/core/packet.js";

function createMockBytes(x) {
    const b = new ByteArray(1000038 * 10);
    let offset = 0;
    for (let i = 0; i < 10; i++) {
        const b2 = new ByteArray(1000000);
        if (i == 9) b2[x + 900] = 255;
        b2[i + 200] = 255;
        const p = new ArbitraryPacket(b2);
        const h = Sha256.fromPacket(p);
        b.set(h.toBytes(), offset);
        offset += 33;
        b.set(p.toBytes(), offset);
        offset += 1000005;
    }
    return b;
}

function atomsFromMock(x) {
    return Atoms.fromBytes(createMockBytes(x));
}

function printMem() {
    console.log(JSON.stringify(process.memoryUsage()));
}

async function foo() {
    printMem();
    const as = [];

    for (let i = 0; i < 10; i++) {
        as.push(atomsFromMock(i));
        printMem();
    }
    await new Promise(r => setTimeout(r, 20000));
    printMem();

    console.log(Atoms.totalCacheCount());
    console.log(Atoms.totalCachedPacketSize());
    console.log(Atoms.totalExpectedCacheSize());
    console.log(as.reduce((oldX, atoms) => oldX += atoms.totalHashSize(), 0));

    as.push(atomsFromMock(1));
        printMem();

    await new Promise(r => setTimeout(r, 20000));
    printMem();

    console.log(Atoms.totalCacheCount());
    console.log(Atoms.totalCachedPacketSize());
    console.log(Atoms.totalExpectedCacheSize());
    console.log(as.reduce((oldX, atoms) => oldX += atoms.totalHashSize(), 0));
}

foo();