import { ByteArray } from "../src/core/byte-array.js";
import { PairTriePacket, Packet } from "../src/core/packet.js";
import { Hash, Sha256, Symbol } from "../src/core/hash.js";
import { HashMap } from "../src/core/map.js";

function foo() {
    const b = new ByteArray(2000000000);
    printMem();
    const m = new HashMap();
    for (let i = 0; i < b.length; i ++) {
        b[i] = (i * i + i % 7 + 18 + i / 7) % 256;
    }
    printMem();
    for (let i = 0; i < 100; i++) {
        m.set(Symbol.fromStr("BLAH " + i),
              Symbol.fromStr("Balagh " + i));
    }

    

    const p0 = PairTriePacket.createFromUnsorted(m);
    b.set(p0.toBytes(), 3000);

    printMem();

    return Packet.parse(b, 3000);
}

async function goo() {
    printMem();
    const p = foo();
    console.log("FOO OVER!");
    printMem();
    console.log("SLEEPING FOR 60");
    await new Promise(r => setTimeout(r, 60000));
    console.log("SLEPT FOR 60");
    printMem();
    const b = new ByteArray(2000000000);
    console.log(p.getLength());
    console.log(p.content.length);
    console.log(p.toBytes().length);
}

function printMem() {
    console.log(process.memoryUsage().heapUsed, 
                process.memoryUsage().heapTotal,
                process.memoryUsage().arrayBuffers);
}

goo();